/*
 *  Ethernet network driver statistics
 *
 *  There are lies, damn lies and statistics.... 
 *
 *  This contains a generic structure for storing statistics 
 *  about an ethernet network interface. It should perhaps be replaced
 *  with something more SNMP like. Not to mention being put somewhere
 *  that it can be got at by other users.
 *
 *  Author:
 *    David Fiddes, D.J@fiddes.surfaid.org
 *    http://www.calm.hw.ac.uk/davidf/coldfire/
 *
 *  COPYRIGHT (c) 1989-1998.
 *  On-Line Applications Research Corporation (OAR).
 *  Copyright assigned to U.S. Government, 1994.
 *
 *  The license and distribution terms for this file may be
 *  found in the file LICENSE in this distribution or at
 * 
 *  http://www.OARcorp.com/rtems/license.html.
 * 
 *  $Id: ns8390.h,v 1.11 1998/02/19 23:02:02 joel Exp $
 */


#ifndef _STATS_H
#define _STATS_H


/***************************************************************************/
/**  Ethernet statistics collection data.                                 **/
 
typedef struct {
  int rx_packets;     /* total packets received         */
  int tx_packets;     /* total packets transmitted      */
  int rx_errors;      /* bad packets received           */
  int tx_errors;      /* packet transmit problems       */
  int rx_dropped;     /* no space in ka9q buffers       */
  int tx_dropped;     /* no space available in ka9q     */
  int rx_interrupts;  /* total number of rx interrupts  */
  int tx_interrupts;  /* total number of tx interrupts  */
  int collisions;

  /* detailed rx_errors: */
  int rx_length_errors;
  int rx_over_errors;   /* receiver ring buff overflow  */
  int rx_crc_errors;    /* recved pkt with crc error    */
  int rx_frame_errors;  /* recv'd frame alignment error */
  int rx_fifo_errors;   /* recv'r fifo overrun          */
  int rx_missed_errors; /* receiver missed packet       */

  /* detailed tx_errors */
  int tx_aborted_errors;
  int tx_carrier_errors;
  int tx_fifo_errors;
  int tx_heartbeat_errors;
  int tx_window_errors;

  /* Number of receive acknowledgements.  */
  int rx_acks;

 /* Number of transmit acknowledgements.  */
  int tx_acks;

  int interrupts;

} eth_statistics;

#endif
